/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * main.c
 * Copyright (C) 2013 Maurice <Maurice.Clerc@WriteMe.com>
 * 
 * Determinant is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Determinant is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#include "stdio.h"
#include "math.h"
#include <stdlib.h>

// For more math, in particular linear algebra
// Do not forget to link to gsl and gslcblas
#include <gsl/gsl_math.h>
#include <gsl/gsl_blas.h>
#include <gsl/gsl_matrix.h>
#include <gsl/gsl_linalg.h>

#define NMax 30 // Maximum size of the square matrix

// Files
FILE *f_matrix;

// Structures
struct matrix
{
 int D;
 double m[NMax][NMax];
};

// Subroutines
double deter(struct matrix M);
void displayMatrix(struct matrix M);
double deter(struct matrix M);

int main()
{
 int column;
 double det;
 int line;
 struct matrix M;
 float zz;
 
 f_matrix = fopen ("f_matrix.txt", "r");

 fscanf(f_matrix,"%i",&M.D);

 for(line=0;line<M.D;line++)
	for(column=0;column<M.D;column++)
 {
	 fscanf(f_matrix,"%f",&zz);
	M.m[line][column]=zz;
 }

	// Display matrix
 displayMatrix(M);
 det=deter(M);
 printf("\nDeterminant = %f",det);

	return (0);
	
}
//==============================================================================
void displayMatrix(struct matrix M)
{
	int i,j;
 printf("\nMatrix %ix%i",M.D,M.D);
	for(i=0;i<M.D;i++)
 {
	printf("\n");
	for(j=0;j<M.D;j++)
	 printf("%3.2f ",M.m[i][j]);
 }
}
//==============================================================================
#include "deter.c"
